from Rryyz.layers import Layer
from Rryyz import utils
import Rryyz.functions as F
import Rryyz.layers as L

class Model(Layer):
  def plot(self,*inputs,to_file="model.png"):
    y = self.forward(*inputs)
    return utils.plot_dot_graph(y,verbose=True,to_file=to_file)
    
class MLP(Model):#Multi-Layer Perceptron，全连接层神经网络
  #fc(full connect),全连接。activation，激活函数，默认是sigmoid
  def __init__(self,fc_output_sizes,activation=F.sigmoid):
    super().__init__()
    self.activation = activation
    self.layers = []

    for i,out_size in enumerate(fc_output_sizes):
      layer = L.Linear(out_size)
      setattr(self,"l" + str(i),layer)
      self.layers.append(layer)

  def forward(self,x):
    for l in self.layers[:-1]:
      x = self.activation(l(x))
    return self.layers[-1](x)